
// cl /Fe wavext.c 

#include <stdio.h>
#include <windows.h>
#include <fcntl.h>

void PrintError(const char* msg){
	LPVOID buf;
	
	/* G[\̒^Bʓ|cperrorɂȂ̂*/
	FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS, NULL, GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &buf, 0, NULL);
	printf(msg,buf);
	LocalFree(buf);
}

//Wavt@Čo
int CheckWav(char* buf,int len){
	__int64 waveheader;
	int wavesize;
	
	wavesize=*(DWORD*)&buf[4];
	waveheader = *(__int64*)&buf[8];
	
	// WAVEfmtH
	if(wavesize+8 >= len || waveheader!=0x20746D6645564157ULL)
		return 0;
	
	return wavesize+8;
}

int CheckOgg(char* buf,int len){
	unsigned char* ubuf = (unsigned char*)buf;
	int size=0,numpage,pagesize,i,fin;
	
	//`NƂɌJԂ
	while(*(DWORD*)&buf[size] == 0x5367674F && size+26<len){
		
		numpage = ubuf[size+26];
		if (size+26+numpage>len) break;
		
		pagesize=0;
		//y[WƂ̃TCYZ
		for(i=0;i<numpage;i++)
			pagesize += ubuf[size+27+i];
		
		//Ō̃y[WH
		fin = (ubuf[size+5] & 4); 
		size += 27 + i + pagesize;
		if(fin) return size;
		
	}
	return 0;
}







int main(int argc,char** argv){
	HANDLE file=NULL,hFilemap=NULL;
	LPVOID addr=NULL;
	char* buf;
	__int64 tsize;
	int size,i,datasize;
	char filename[256];
	FILE* f;
	int found=0;
	
	if(argc!=2){
		printf("usage: %s <filename>\n",argv[0]);
		return 0;
	}
	
	// I[v
	file = CreateFile(argv[1],GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(file == INVALID_HANDLE_VALUE) {
		PrintError("t@CI[vɎs܂:%s\n");
		return -1;
	}
	
	tsize = GetFileSize(file,NULL);
	if(tsize>=0x40000000UL){
		printf("1GBȏ̃t@C͔ΉłB\n");
		goto last;
	}
	size = tsize;
	
	//}bsO
	hFilemap = CreateFileMapping(file, NULL, PAGE_READONLY, 0,0,NULL);
	if(hFilemap) addr = MapViewOfFile(hFilemap, FILE_MAP_READ, 0,0,0);
	if (!hFilemap || !addr) {
		PrintError("t@C}bsOɎs܂:%s\n");
		goto last;
	}
	
	buf = addr;
	
	for(i=0;i<size-12;i++){
		if(i%1000000==0){
			setmode(_fileno(stdout), O_BINARY );
			printf("%ld/%ld byte...\r",i,size);
			setmode(_fileno(stdout), O_TEXT );
		}
		
		datasize=0;
		
		if(buf[i]=='R' && *(DWORD*)&buf[i] == 0x46464952){ //RIFF
			datasize = CheckWav(&buf[i],size-i);
			
			if(datasize>0)
				sprintf(filename,"sound%03d.wav",found++);
		}
		else if(buf[i]=='O' && *(DWORD*)&buf[i] == 0x5367674F){ //OggS
			datasize = CheckOgg(&buf[i],size-i);
			
			if(datasize>0)
				sprintf(filename,"sound%03d.ogg",found++);
		
		}
		
		if(datasize>0) {
			f = fopen(filename,"wb");
			if (f) {
				fwrite(&buf[i],datasize,1,f);
				fclose(f);
			}
			printf("file : %s                       \n",filename);
			i += datasize-1;
		}
	}
	
last:
	if(buf) UnmapViewOfFile(buf);
	if(hFilemap) CloseHandle(hFilemap);
	CloseHandle(file);
	
	return 0;
}

